/*****************************************************************************/
/*                                                                           */
/*  HyperPanel OS                       File "stm32m3/src/signal_vmit.h"     */
/*  Board - Constants and definitions specific to stm32m3.                   */
/*                                                                           */
/*  Author : JYA/TE/FA                  Last modification : 15/04/2024       */
/*                                                                           */
/*****************************************************************************/

#ifndef SIGNAL_H                       /* Begin conditionnal compilation     */
#define SIGNAL_H                       /* Identifier for this include        */


/* Macro for "vmit.c" .......................................................*/

#include <armv7m.h>
extern const Ref_nvic ref_nvic[]  ;

#define SIGNAL_RAISE(a) {register INT nirq                     ; \
                         nirq = ref_nvic[a].num                ; \
                         nvic->isp[nirq/32] = 1 << (nirq % 32) ; }

#define SIGNAL_CLEAR(a) {register INT nirq                     ; \
                         nirq = ref_nvic[a].num                ; \
                         nvic->icp[nirq/32] = 1 << (nirq % 32) ; }


/* DWT samplig macro for tl_vmitth.c ........................................*/

#define DWT_CYCC (*(UINT*) 0xE0001004)

extern void add_cycc_irq(void);
#define ADD_CYCC_IRQ add_cycc_irq()

/* GPIO macro for oscilloscope profiling ......................................

   Name    ST name  Function              Macro           
   ------  -------  --------------------  -----------------

*/

#define GPIOA_BA        0x40020000     /* GPIOA                              */
#define GPIOB_BA        0x40020400     /* GPIOB                              */
#define GPIOC_BA        0x40020800     /* GPIOC                              */
#define GPIOD_BA        0x40020C00     /* GPIOD                              */
#define GPIOE_BA        0x40021000     /* GPIOE                              */
#define GPIOH_BA        0x40021400     /* GPIOH                              */
#define GPIOF_BA        0x40021800     /* GPIOF                              */
#define GPIOG_BA        0x40021C00     /* GPIOG                              */


#define GPIO_BOOT(a)     
#define GPIO_TIM(a)      

#define GPIO_CPU(a)      
#define GPIO_VMIT(a)     
#define GPIO_VMK(a)      
#define GPIO_VMIO(a)     

#define IASY0(a)         
#define IASY1(a)         
#define IASY2(a)         
#define GPIO_ASY_IRQ(n,a) 

#define GPIO_ASY(a)      
#define GPIO_LED(a)      
#define GPIO_RCU(a)      
#define GPIO_KBD(a)      

#define GPIO_VMK_LOST(a) 
#define GPIO_VMIO_LOST(a)
#define GPIO_MMI(a)      

#define GPIO_PROD(a)     
#define GPIO_CONS(a)     
#define GPIO_LIGHTS(a)   
#define GPIO_SEND(a)     

#endif                                 /* End of conditionnal compilation.   */
