/*****************************************************************************/
/*                                                                           */
/*  Hyperpanel OS                       File "include/tsk_netlib.h           */
/*  Interface definitions for "tsk_netlib.c"                                 */
/*                                                                           */
/*  Author : JYA                        Last modification : 11/12/2022       */
/*                                                                           */
/*  (c) Copyright Hyperpanel Lab, All Rights Reserved                        */
/*  IDDN.FR.001.320001.*.S.P.1990.000.10000                                  */
/*                                                                           */
/*****************************************************************************/

/*  Some explanations ========================================================


         1  Defines
         2  Structures and typedefs
         3  Public variables
         4  Prototypes of public procedures
         5  RAM data to be included in space_appcont_xyz.c
*/

#ifndef VMK_NETLIB_H                   /* If this file is not already        */
#define VMK_NETLIB_H                   /* included, include it.              */


/*
    2    Structures and typedefs
    ____________________________


*/

typedef struct                         /* Files req/ecr/lec/aut et compteur  */
  BEGIN                                /* ---------------------------------- */
    INT            iod               ; /* netlib IOD value                   */
    USHORT         nodeid            ; /* Our associated node identifier     */
  END              Net_iod           ; /* ---------------------------------- */

/*
    3    Public variables
    _____________________
*/


/*
    4    Prototypes of public procedures
    ____________________________________
*/

IWORD net_list_drivers    (char*,int,int*                                    );
IWORD net_list_devices    (const char*,char*,int,int*                        );
IWORD net_list_protocols  (const char*,char*,int,int*                        );
IWORD net_list_tags       (const char*,char*,int,int*                        );
IWORD net_tag_number      (const char*,const char*,int*                      );
IWORD net_tag_name        (const char*,int, char*, int                       );

IWORD net_open_device     (const char*,const char*,const char*,int*          );
IWORD net_close_device    (int                                               );
IWORD net_alloc_sub       (int,const char*,int*                              );
IWORD net_free_sub        (int                                               );
IWORD net_alloc_sub       (int,const char*,int*                              );
IWORD net_free_sub        (int                                               );

IWORD net_bufsize         (int,int,int*,int*,int*                            );
IWORD net_write           (int,unsigned char*,int,int                        );
IWORD net_send            (int,unsigned char*,int,int*                       );
IWORD net_read            (int,unsigned char*,int,int*                       );
IWORD net_receive         (int,int,int,int*                                  );

IWORD net_setval          (int,const char*                                   );
IWORD net_getval          (int,char*,int                                     );

IWORD net_nodeid_req      (int,const unsigned char*,int                      );
IWORD net_nodeid_resp     (int,const unsigned char*,int,int                  );
IWORD net_nodename_req    (int,const char*                                   );
IWORD net_nodename_resp   (int,const char*                                   );
IWORD net_objectid_req    (int,int,int*                                      );
IWORD net_objectid_resp   (int,int                                           );
IWORD net_send_cmd        (int,int,const unsigned char*,int                  );
IWORD net_send_val        (int,int,const unsigned char*,int                  );


#endif                                 /* End of VMK_IOLIB_H                 */

#ifdef SPACE_APPCONT_XYZ_DATA_C

INT           netlib_modd [NET_NB_MODD]  ; /* MODD values storage                */
UCHAR         netlib_iodnb[NET_NB_MODD]  ;
Net_iod       netlib_iod  [NET_NB_IOD]   ;

const INT     netlib_nbmodd = NET_NB_MODD; /* Size of the "iolib_modd[]" array   */
const INT     netlib_nbiod  = NET_NB_IOD ; /* Size of the "iolib_iod[]" array    */

#endif                                 /* End of SPACE_APPCONT_XYZ_C         */


